=== src/core/g_config_manager/CMakeLists.txt ===


FILE(GLOB "src_config_manager" "*.c")

SET(src_g_shared_map "${src_config_manager}" PARENT_SCOPE)
