=== debian/changelog ===
gfal2 (2.10.2-1) unstable; urgency=medium

  * New upstream release
  * Add dbg package

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Wed, 02 Dec 2015 17:13:10 +0100
