## gfal2 2.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,8 +43,8 @@
 set (OUTPUT_NAME_TRANSFER "gfal_transfer")
 
 set (VERSION_MAJOR  2)
-set (VERSION_MINOR  10)
-set (VERSION_PATCH  2)
+set (VERSION_MINOR  11)
+set (VERSION_PATCH  1)
 set (VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
 add_definitions(-DVERSION="${VERSION_STRING}")
