=== debian/changelog ===
gfal2 (2.11.1-1) unstable; urgency=medium

  * New upstream release

 -- Mattias Ellert <mattias.ellert@fysast.uu.se>  Tue, 10 May 2016 18:01:02 +0200
